   Comment*--------------------------------------
    FileName: WinRichEdit000.ASM  
    Notes: originated by WinRichEdit00p4.asm
           for the test of EM_GETMODIFY & EM_SETMODIFY message
    Begins: 61.07.02
    Written by: MAC
   *---------------------------------------------

   .386
   .MODEL  FLAT, STDCALL
   OPTION CASEMAP: NONE
   
   INCLUDE  \MASM32\INCLUDE\WINDOWS.INC
   
   INCLUDE \MASM32\INCLUDE\USER32.INC
   INCLUDE \MASM32\INCLUDE\KERNEL32.INC
   INCLUDE \MASM32\INCLUDE\SHELL32.INC
   INCLUDE \MASM32\INCLUDE\GDI32.INC
   INCLUDE  \MASM32\INCLUDE\COMCTL32.INC
   INCLUDE \MASM32\INCLUDE\COMDLG32.INC
   INCLUDE \MASM32\INCLUDE\IMM32.INC
   INCLUDE \MASM32\INCLUDE\WINSPOOL.INC

   INCLUDELIB \MASM32\LIB\USER32.LIB
   INCLUDELIB \MASM32\LIB\KERNEL32.LIB
   INCLUDELIB \MASM32\LIB\SHELL32.LIB
   INCLUDELIB \MASM32\LIB\GDI32.LIB
   INCLUDELIB \MASM32\LIB\COMCTL32.LIB
   INCLUDELIB \MASM32\LIB\COMDLG32.LIB
   INCLUDELIB \MASM32\LIB\IMM32.LIB
   INCLUDELIB \MASM32\LIB\WINSPOOL.LIB
   
      ;Set_Parameter_Types_for_Procedure_RichEdit
      RichEdit  PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
         
      .DATA
         ;Set_Windows_Base_Structs
         WinClass        WNDCLASSEX <>
         Msg             MSG <> 
         Rect            RECT <>
         ScreenRect      RECT <>
         Bitmap          BITMAP <>
         PaintStruc      PAINTSTRUCT <>
         TextMetrics     TEXTMETRIC <>
         
         ;Set_Windows_Base_Variables
         CommandLine  DWORD  00000000H
         hInstance    DWORD  00000000H
         hWindow      DWORD  00000000H
         hStatusBar   DWORD  00000000H
         hIcon        DWORD  00000000H
         hMenu        DWORD  00000000H
         hFont        DWORD  00000000H
         hDC          DWORD  00000000H
         hMemDC       DWORD  00000000H
         hBitmap      DWORD  00000000H
         hBrush       DWORD  00000000H
         hPaintStruc  DWORD  00000000H
         hWinPoStruc  DWORD  00000000H
         NullByte     BYTE   00H
         
         ;Set_RichEdit_Windows_Base_Variables
         RichEditDLL  BYTE   "RICHED32.DLL",00H
         RichEdit_Class      BYTE  "RICHEDIT"
         hRichEdit    DWORD  00000000H  
         RichEditAddress     DWORD  00000000H
         hRichEditDLL DWORD  00000000H
         hGuiFont     DWORD  00000000H
        
         Win_Left   EQU  50
         Win_Top    EQU  100
         Win_Width  EQU  720
         Win_Height EQU  420

         BackColor  EQU  Button_Face       
         ;Set_Window_Style
         CW_Style   EQU  Left_Arranged
         ClassName  BYTE  "WinRichEdit_Class", NULL
         TitleName  BYTE  "WinRichEditor ver.0.0 > ", NULL
         Icon_ID    EQU  100  
         Menu_ID    EQU  200
   
   
   
      .CODE
      WinMain:

         ;This Block is 'WinFrame.PreSet.Part' of Window.System 
         INVOKE GetCommandLine
         MOV  CommandLine, EAX    
         INVOKE  GetModuleHandle, NULL  
         MOV  hInstance, EAX          
         MOV     WinClass.hInstance, EAX   
         MOV     WinClass.cbSize, SizeOf WNDCLASSEX
         MOV     WinClass.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
         MOV     WinClass.lpfnWndProc, OFFSET WinProc
         MOV     WinClass.cbClsExtra, NULL
         MOV     WinClass.cbWndExtra, NULL
         MOV     WinClass.hbrBackground, COLOR_WINDOW+1
         MOV     WinClass.lpszMenuName, NULL
         MOV     WinClass.lpszClassName, OFFSET ClassName
         MOV     WinClass.hIconSm, NULL
               
         INVOKE  LoadCursor, NULL, IDC_ARROW   
         INVOKE  LoadIcon, hInstance, Icon_ID        
         MOV     WinClass.hIcon, EAX
         INVOKE  LoadMenu, hInstance, Menu_ID           
         MOV     hMenu, EAX
         INVOKE  RegisterClassEx, ADDR WinClass        
         INVOKE CreateWindowEx, WS_EX_OVERLAPPEDWINDOW,        
                ADDR ClassName, ADDR TitleName,
                WS_OVERLAPPEDWINDOW,
                Win_Left, Win_Top, Win_Width, Win_Height,
                NULL, NULL, hInstance, NULL
         
         MOV  hWindow, EAX
         INVOKE  SetMenu, hWindow, hMenu
         INVOKE ShowWindow, hWindow, SW_SHOWNORMAL
         INVOKE UpdateWindow, hWindow                   
        
                                  
         ;This Block is 'Message.Processing.Part' of Window.System 
         MESSAGE_PROCESSING_LOOP:
            INVOKE  GetMessage, ADDR Msg, NULL, 0, 0      
               .IF EAX == NULL  
                  JMP  END_MESSAGE_LOOP
               .ENDIF   
            INVOKE TranslateMessage, ADDR Msg                  
            INVOKE DispatchMessage, ADDR Msg    
            JMP  MESSAGE_PROCESSING_LOOP
         END_MESSAGE_LOOP:
         INVOKE  ExitProcess, EAX
             
   
         ;This Block is 'Major Message.Processing.Part'
         WinProc  PROC  hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

            .IF uMsg == WM_CREATE
               INVOKE LoadLibrary, ADDR RichEditDLL
               MOV  hRichEditDLL, EAX
               INVOKE GetClientRect, hWin, ADDR Rect
               MOV  EAX, Rect.right
               MOV  EBX, Rect.bottom
               INVOKE RichEdit, 0, 0, EAX, EBX, hWin, 666       
               MOV  hRichEdit, EAX
               
            .ELSEIF uMsg == WM_COMMAND
               JMP  MENU_COMMAND_PROCESS
               
            .ELSEIF uMsg == WM_SIZE
               INVOKE  BeginDeferWindowPos, 1
               MOV  hWinPoStruc, EAX
               MOVZX  EAX, WORD PTR lParam+00H
               MOVZX  EBX, WORD PTR lParam+02H
               INVOKE  DeferWindowPos,  hWinPoStruc, hRichEdit, NULL, 0, 0, EAX, EBX, \
                                        SWP_NOACTIVATE or SWP_NOZORDER or SWP_NOMOVE
               INVOKE  EndDeferWindowPos, hWinPoStruc
               
            .ELSEIF uMsg == WM_SETFOCUS   
               INVOKE  SetFocus,  hRichEdit
               
            .ELSEIF uMsg == WM_CLOSE
               JMP  CLOSE_PROCESS
               
            .ELSEIF uMsg == WM_DESTROY
               JMP  QUIT_PROCESS
            .ENDIF
            
            JMP  DEFAULT_MESSAGE_PROCESS


                
            MENU_COMMAND_PROCESS:
               .IF wParam == 9999
                  JMP  EXIT_PROCESS
                  
               .ELSEIF wParam == 1001
                  JMP  NEW_FILE_PROCESS
                  
               .ELSEIF wParam == 1002
                  JMP  OPEN_FILE_PROCESS
                  
               .ELSEIF wParam == 1003
                  JMP  SAVE_FILE_PROCESS
                  
               .ELSEIF wParam == 1004
                  JMP  SAVE_AS_FILE_PROCESS
                  
               .ELSEIF wParam == 9001
                  JMP  HELP_PROCESS
                  
               .ELSEIF wParam == 9009
                  JMP  ABOUT_PROCESS
               .ENDIF   
                  
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
            .DATA
               hFile        DWORD  00000000H
               FileSize     DWORD  00000000H
               TextSize     DWORD  00000000H
               ReadedBytes  DWORD  00000000H
               WritedBytes  DWORD  00000000H
               hFileBuffer  DWORD  00000000H
  
               DefaultFileName     BYTE  "\Untitled.txt", 0
               FileNameStruct      OPENFILENAME <>
               FileNameBuffer      BYTE  260 DUP (00H)
               WindowTitleBuffer   BYTE  280 DUP (00H)
               ;WorkingFileFlag     BYTE  0
               OpenProgressTitle   BYTE  "Open Progress", 0
               SaveProgressTitle   BYTE  "Save Progress", 0
               SaveAsProgressTitle BYTE  "SaveAs Progress", 0
               
               OpenFileFilter  BYTE  "AllFiles ( *.* )", 0
                               BYTE  "*.*", 0   
                               BYTE  "Assembly (*.asm)", 0   
                               BYTE  "*.ASM", 0   
                               BYTE  "Resource (*.rc)", 0   
                               BYTE  "*.RC", 0   
                               BYTE  "TextFile (*.txt)", 0   
                               BYTE  "*.TXT", 0   
                               BYTE  0

               
            .CODE
            NEW_FILE_PROCESS:
               INVOKE SendMessage, hRichEdit, EM_GETMODIFY, 0, 0
               .IF EAX
                  ;if the Contents in an RichEdit.control has been modified,
                  CALL  WORKING_FILE_SAVE_ROUTINE
                  .IF EAX == IDCANCEL
                     JMP  DEFAULT_MESSAGE_PROCESS
                  .ENDIF   
               .ENDIF
               
               ;Clear_Contents_of_RichEdit
               INVOKE SetWindowText, hRichEdit, ADDR NullByte
               INVOKE GetCurrentDirectory, SizeOf FileNameBuffer, ADDR FileNameBuffer  
               ;Append_DefaultFileName_to FileNameBuffer
               XOR  EAX,EAX 
               MOV  EDI, OFFSET FileNameBuffer
               MOV  ECX, SizeOf FileNameBuffer
               .REPEAT
                  ;Find_EAX_by_Byte_at_EDI
                  SCASB
               .UNTIL  ZERO?
                 
               ;Backward_One_Byte_from_EAX_found_Point
               DEC  EDI                                 
               ;Adds '\Untitled.txt' String to Current Path Stream
               MOV  ESI, OFFSET DefaultFileName
               MOV  ECX, SizeOf DefaultFileName
               ;Copy_ECX_Bytes_from_ESI_to_EDI
               REP  MOVSB
               
               ;Append_String_to_Begin_of WindowTitleBuffer
               XOR  EAX,EAX 
               MOV  EDI, OFFSET WindowTitleBuffer
               MOV  ECX, SizeOf WindowTitleBuffer
               ;Writes <string> to BeginAddress of specified Buffer
               MOV  ESI, OFFSET TitleName
               MOV  ECX, SizeOf TitleName
               REP  MOVSB

               ;Append_String_to WindowTitleBuffer, FileNameBuffer
               XOR  EAX,EAX 
               MOV  EDI, OFFSET WindowTitleBuffer
               MOV  ECX, SizeOf WindowTitleBuffer
               .REPEAT
                  ;Find_EAX_by_Byte_at_EDI
                  SCASB
               .UNTIL  ZERO?
               
               ;Backward_One_Byte_from_EAX_found_Point
               DEC  EDI                                 
               ;Adds <FileNameBuffer string> to Current Path Stream
               MOV  ESI, OFFSET FileNameBuffer
               MOV  ECX, SizeOf FileNameBuffer
               ;Copy_ECX_Bytes_from_ESI_to_EDI
               REP  MOVSB
               
               ;Display_Window_Title_with_String_of WindowTitleBuffer
               INVOKE  SetWindowText, hWin, ADDR WindowTitleBuffer
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
            OPEN_FILE_PROCESS:
               INVOKE SendMessage, hRichEdit, EM_GETMODIFY, 0, 0
               .IF EAX
                  ;if the Contents in an RichEdit.control has been modified,
                  CALL  WORKING_FILE_SAVE_ROUTINE
                  .IF EAX == IDCANCEL
                     JMP  DEFAULT_MESSAGE_PROCESS
                  .ENDIF   
               .ENDIF
               
               ;Write_OpenFileName_Parameters_into_Field_of  FileNameStruct
               MOV  EAX, hWin
               MOV  FileNameStruct.hWndOwner, EAX

               MOV  EAX, hInstance
               MOV  FileNameStruct.hInstance, EAX
            
               MOV  FileNameStruct.lStructSize, SizeOf OPENFILENAME
               MOV  FileNameStruct.lpstrFilter, OFFSET OpenFileFilter
               MOV  FileNameStruct.lpstrFile, OFFSET FileNameBuffer
               MOV  FileNameStruct.nMaxFile, SizeOf FileNameBuffer
              
               MOV  FileNameStruct.lpstrTitle, OFFSET OpenProgressTitle
               MOV  FileNameStruct.Flags, OFN_EXPLORER or OFN_FILEMUSTEXIST or OFN_LONGNAMES or OFN_HIDEREADONLY   
               
               ;Display_File_Open_Dialog_Box_for FileNameStruct
               INVOKE GetOpenFileName, ADDR FileNameStruct
               .IF EAX == FALSE
                  JMP  DEFAULT_MESSAGE_PROCESS
               .ENDIF   
   
               ;Display_Window_Title_with_String_of FileNameBuffer
               INVOKE SetWindowText,  hWin, ADDR FileNameBuffer
               ; Open_Exist_File  FileNameBuffer
               INVOKE CreateFile,  ADDR FileNameBuffer, GENERIC_READ, NULL, NULL, 
                                   OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL 
               MOV  hFile, EAX
               
               INVOKE GetFileSize, hFile, NULL
               MOV  FileSize, EAX
               ;Make_Global_Buffer_Memory
               INVOKE  GlobalAlloc, GMEM_FIXED, FileSize
               MOV  hFileBuffer, EAX
               
               ;Read_File_to  hFileBuffer
               INVOKE ReadFile,  hFile, hFileBuffer, FileSize, ADDR ReadedBytes, NULL
               ;Display_FileBuffer_Text_on_RichEditBox
               INVOKE  SetWindowText, hRichEdit, hFileBuffer
               
               INVOKE  CloseHandle, hFile
               ;Release_Global_FileBuffer_Memory
               INVOKE  GlobalFree, hFileBuffer
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
   
            SAVE_FILE_PROCESS:
               CALL  SAVE_MODE_SELECT_ROUTINE
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
            SAVE_AS_FILE_PROCESS:
               CALL  SAVE_AS_ROUTINE
               .IF EAX == IDCANCEL
                  ;Set_uMessage_to_Meaningless
                   MOV  uMsg, 0000000Fh     ;IDLE
               .ENDIF   
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
            HelpTitle  BYTE  "Help for RichEdit Control", 0
            
            HelpText   BYTE  "About RichEdit Control >", 0DH,0AH
                BYTE  " ", 0DH,0AH
                BYTE  "This Program is a simple Text Editor which based on Win32 RichEdit Control.", 0DH,0AH
                BYTE  " ", 0DH,0AH
                BYTE  "A rich edit control is a window in which the user can enter and edit text.", 0DH,0AH
                BYTE  "The text can be assigned character and paragraph formatting, ",0DH,0AH
                BYTE  "and can include embedded OLE objects. ",0DH,0AH
                BYTE  " ",0DH,0AH
                BYTE  "Rich edit controls provide a programming interface for formatting text. ",0DH,0AH
                BYTE  "However, an application must implement any user interface components necessary      ",0DH,0AH
                BYTE  "to make formatting operations available to the user. ",0
                      
            HELP_PROCESS:
               ;Display_Info_Message_Box
               INVOKE  MessageBox,  NULL, ADDR HelpText, ADDR HelpTitle, MB_ICONINFORMATION
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
            AboutTitle    BYTE  "Windows RichEdit.DLL Application",0
            AboutMessage  BYTE  "Win32.MAL's WinRichEditor Ver.0.0", 0DH,0AH 
                          BYTE  "AH.61.01.16   Written by MAC",0

            ABOUT_PROCESS:
               ;Display_About_Program_Message_Box
               INVOKE ShellAbout, hWin, ADDR AboutTitle, ADDR AboutMessage, hIcon
            JMP  DEFAULT_MESSAGE_PROCESS
   
   
   
   
            CLOSE_PROCESS:
               ;Set  uMessage, Meaningless
               MOV  uMsg, 0000000Fh     ;IDLE
               
            EXIT_PROCESS:   
               INVOKE SendMessage, hRichEdit, EM_GETMODIFY, 0, 0
               .IF EAX
                  ;if the Contents in an RichEdit.control has been modified,
                  CALL  WORKING_FILE_SAVE_ROUTINE
                  .IF EAX == IDCANCEL
                     JMP  DEFAULT_MESSAGE_PROCESS
                  .ENDIF   
               .ENDIF
               
            QUIT_PROCESS: 
               ;Release_Library
               INVOKE  FreeLibrary, hRichEditDLL
               
               ;Send_Quit_Message_to_Program_Manager
               INVOKE  PostQuitMessage, NULL
               ;Function moves 'WM_QUIT' MESSAGE to Program.Manager,
               ;then, Program.Manager pushes 'Quit.Code'(00H) into Message.Query.Buffer
   
            DEFAULT_MESSAGE_PROCESS: 
               ;Do_Default_Processing_for_Idle_Messages
               INVOKE  DefWindowProc, hWin, uMsg, wParam, lParam
            ;Return_to_Message_Processing_Loop
            RET 
            
         WinProc  ENDP
   
   
   
   
   
   
 
         ;Begin_of_Procedure_RichEdit
         RichEdit  PROC  x:DWORD, y:DWORD, Wd:DWORD, Ht:DWORD, hParent:DWORD, ID:DWORD
            ;Create_RichEdit_Window_in_Memory
            INVOKE CreateWindowEx, NULL, ADDR RichEdit_Class, 0,
                   WS_VISIBLE or WS_CHILDWINDOW or \
                   ES_MULTILINE or WS_VSCROLL or WS_HSCROLL or \
                   ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_NOHIDESEL,
                   x, y, Wd, Ht, hParent, ID, hInstance, NULL
            RET
         RichEdit  ENDP
   
   
   
   
         WorkSaveTitle    BYTE  "Working File Save Progress",0
         WorkSaveMessage  BYTE  "Working File is not saved..", 0DH,0AH
                          BYTE  "Do you want save it, Now ?",0
         
         WORKING_FILE_SAVE_ROUTINE:
            ;Display_Message_Box_with_Yes_No_Cancel_Button  WorkSaveTitle, WorkSaveMessage             
            INVOKE  MessageBox,  NULL, ADDR WorkSaveMessage, ADDR WorkSaveTitle,
                                 MB_SYSTEMMODAL or MB_ICONEXCLAMATION or MB_YESNOCANCEL
                                 
            .IF EAX == IDYES
               JMP  SAVE_MODE_SELECT_ROUTINE
            .ENDIF    
         RET
   
   
         SAVE_MODE_SELECT_ROUTINE:
            ;Create_File_with_check_Existing
            INVOKE CreateFile,  ADDR FileNameBuffer, GENERIC_WRITE, NULL, NULL, 
                                TRUNCATE_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL
            
            .IF EAX == INVALID_HANDLE_VALUE
               JMP  SAVE_AS_ROUTINE
            .ELSE   
               JMP  SAVE_ROUTINE
            .ENDIF
            
         SAVE_AS_ROUTINE:
            ;Write_SaveAsFileName_Parameters_into FileNameStruct
            MOV  EAX, hWindow
            MOV  FileNameStruct.hWndOwner, EAX
            
            MOV  EAX, hInstance
            MOV  FileNameStruct.hInstance, EAX
            ;
            MOV  FileNameStruct.lStructSize, SizeOf OPENFILENAME
            MOV  FileNameStruct.lpstrFilter, OFFSET OpenFileFilter
            MOV  FileNameStruct.lpstrFile, OFFSET FileNameBuffer
            MOV  FileNameStruct.nMaxFile, SizeOf FileNameBuffer
             
            MOV  FileNameStruct.lpstrTitle, OFFSET SaveAsProgressTitle
            MOV  FileNameStruct.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT
            
            ;Display_File_Save_Dialog_Box
            INVOKE GetSaveFileName, ADDR FileNameStruct
            .IF EAX == FALSE
               ;FALSE(=00000000H) is same with Application Quit Code
               MOV  EAX, IDCANCEL
               ;Cancel_Code equals '2'(00000002H)
               RET
            .ENDIF
            
            ;Create_File_with FileNameBuffer
            INVOKE CreateFile,  ADDR FileNameBuffer, GENERIC_WRITE, NULL, NULL, 
                                CREATE_ALWAYS, FILE_ATTRIBUTE_ARCHIVE, NULL
   
         SAVE_ROUTINE:
            ;Save_File_Handle_to  hFile
            MOV  hFile, EAX
            ;Get_Length_of_RichEdit_Text
            INVOKE GetWindowTextLength, hRichEdit
            ;Add_One_Byte_to_Text_Length
            INC  EAX
            ;Save_RichEdit_Text_Size
            MOV  TextSize, EAX
            ;Mount_Global_Buffer_Memory_as TextSize
            INVOKE  GlobalAlloc, GMEM_FIXED, TextSize
            ;Save_Buffer_Memory_Handle
            MOV  hFileBuffer, EAX
            ;Copy_RichEdit_Text_to hFileBuffer as TextSize
            INVOKE GetWindowText,  hRichEdit, hFileBuffer, TextSize
            ;Write_EditBox_FileBuffer_to hFile
            INVOKE WriteFile, hFile, hFileBuffer, TextSize, ADDR WritedBytes, NULL
            
            ;Close_File_Handle
            INVOKE  CloseHandle, hFile                 
            ;Unmount_Global_FileBuffer_Memory
            INVOKE  GlobalFree, hFileBuffer 
            ;Display_Main_Window_Title_with_String of FileNameBuffer
            INVOKE SetWindowText,  hWindow, ADDR FileNameBuffer
            ;Clear_Modification_Flag
            INVOKE  SendMessage, hRichEdit, EM_SETMODIFY, FALSE, 0
            MOV  EAX, TRUE
         RET
   
   
      END  WinMain
   
   End
   

